;
;	TEST690.ASM					MPB  Ver 1.0
;	Generic source code for 16F690
;	Setup for digital input, but includes statements for analogue
;	Includes ADC and delay subroutines
;
;*********************************************************************

	PROCESSOR 16F690	; Specify MCU for assembler
	__CONFIG 00E5		; MCU configuration bits
				; PWRT on, MCLR enabled 
				; Internal Clock (default 4MHz)
	INCLUDE "P16F690.INC"	; Standard register labels

Hico	EQU	20		; GPR labels
Loco	EQU	21
GPR2	EQU	22

; 	Setup analogue/digital inputs....................

	BANKSEL	ANSEL		; Select Bank 2
	CLRF	ANSEL		; Port A/C digital I/O
	CLRF	ANSELH		; Port B/C digital I/O

;	BSF	ANSEL,0		; A0 analogue input
;	BSF	ANSEL,1		; A1 analogue input
;	BSF	ANSEL,2		; A2 analogue input
;	BSF	ANSEL,3		; A3 analogue input
;	BSF	ANSEL,4		; A4 analogue input
;	BSF	ANSEL,5		; A5 analogue input
;	BSF	ANSEL,6		; A6 analogue input
;	BSF	ANSEL,7		; A7 analogue input
;	BSF	ANSELH,0	; A8 analogue input
;	BSF	ANSELH,1	; A9 analogue input
;	BSF	ANSELH,2	; A10 analogue input
;	BSF	ANSELH,3	; A11 analogue input


;	Set data direction and ADC clock .......................

	BANKSEL	TRISC		; Select Bank 1
	CLRF	TRISC		; Initialise Port C for output
	MOVLW	B'00010000'	; A/D clock setup code
	MOVWF	ADCON1		; A/D clock = fosc/8

; 	Initialise port data and ADC ...........................

	BANKSEL PORTC		; Select bank 0
	CLRF	PORTC		; Clear display outputs
	MOVLW	B'00000000'	; Analogue input setup code
	MOVWF	ADCON0		; Left justify, Vref=5V, 
				; Select RA0, done, disable A/D 

; ADC inputsubroutine, returns ADRESH in W......................
		
GetAD	BSF	ADCON0,1	; start ADC..
wait	BTFSC	ADCON0,1	; ..and wait for finish
	GOTO	wait
	MOVF	ADRESH,W	; store result high byte
	RETURN

; Delay subroutine, uses Hico ..................................

Delay	CLRF	Loco	
fast	DECFSZ	Loco		 
	GOTO	fast
	DECFSZ	Hico
	GOTO	Delay
	RETURN

Main loop ******************************************************

start	CALL 	GetAD
	MOVWF	Hico
	CALL 	Delay
	GOTO	Start

	END	; Terminate assembler **************************



