; ************************
; KEY690.ASM	
; MPB  Ver 1.0
; Demo program scans 
; a keypad and
; displays two digits
;*************************

; MCU setup directives

 PROCESSOR 16F690	
 __CONFIG 00C4			
 INCLUDE "P16F690.INC"
DIGIT	EQU	20		
	
; Setup for digital inputs

	BANKSEL	ANSEL		
	CLRF	ANSEL		
	CLRF	ANSELH		

; Set port data direction

	BANKSEL	TRISA		
	CLRF	TRISA		
	CLRF	TRISC		

; Initialise ports

	BANKSEL PORTA		
	MOVLW	0FF		
	MOVWF	PORTA		
	CLRF	PORTC		

; Main loop shows digits

Next	CLRF	DIGIT		
	CALL	Scan
	BTFSS	DIGIT,4
	GOTO	Next

	BCF	DIGIT,4
	SWAPF	PORTC
	MOVF	PORTC,W
	ANDLW	0F0
	MOVWF	PORTC
	
	MOVF	DIGIT,W
	IORWF	PORTC
	GOTO	Next	

; Scan keypad subroutine

Scan	BCF	PORTA,3
	BTFSS	PORTB,6
	GOTO	one
	BTFSS	PORTB,5
	GOTO	four
	BTFSS	PORTB,4
	GOTO	seven
	BSF	PORTA,3

	BCF	PORTA,2
	BTFSS	PORTB,7
	GOTO	zero
	BTFSS	PORTB,6
	GOTO	two
	BTFSS	PORTB,5
	GOTO	five
	BTFSS	PORTB,4
	GOTO	eight
	BSF	PORTA,2

	BCF	PORTA,4
	BTFSS	PORTB,6
	GOTO	three
	BTFSS	PORTB,5
	GOTO	six
	BTFSS	PORTB,4
	GOTO	nine
	BSF	PORTA,4

	RETURN

; Get number when key hit

zero	MOVLW	010
	MOVWF	DIGIT
	BTFSS	PORTB,7
	GOTO 	zero
	GOTO 	Scan

one	MOVLW	011
	MOVWF	DIGIT
	BTFSS	PORTB,6
	GOTO	one
	GOTO 	Scan
	
two	MOVLW	012
	MOVWF	DIGIT
	BTFSS	PORTB,6
	GOTO	two
	GOTO 	Scan
	
three	MOVLW	013
	MOVWF	DIGIT
	BTFSS	PORTB,6
	GOTO	three
	GOTO 	Scan
	
four	MOVLW	014
	MOVWF	DIGIT
	BTFSS	PORTB,5
	GOTO	four
	GOTO 	Scan
	
five	MOVLW	015
	MOVWF	DIGIT
	BTFSS	PORTB,5
	GOTO	five
	GOTO 	Scan
	
six	MOVLW	016
	MOVWF	DIGIT
	BTFSS	PORTB,5
	GOTO	six
	GOTO 	Scan
	
seven	MOVLW	017
	MOVWF	DIGIT
	BTFSS	PORTB,4
	GOTO	seven
	GOTO 	Scan

eight	MOVLW	018
	MOVWF	DIGIT
	BTFSS	PORTB,4
	GOTO	eight
	GOTO 	Scan
	
nine	MOVLW	019
	MOVWF	DIGIT
	BTFSS	PORTB,4
	GOTO	nine
	GOTO 	Scan
	
	END ; of program



