;
;	LPC1.ASM					MPB  Ver 1.0
;	Test program for LPC demo board
; 	Rotate LED, pot controls the speed
;
;*********************************************************************

	PROCESSOR 16F690	; Specify MCU for assembler
	__CONFIG 00E5		; MCU configuration bits
				; PWRT on, MCLR enabled 
				; Internal Clock (default 4MHz)
	INCLUDE "P16F690.INC"	; Standard register labels

Loco	EQU	20		; GPR labels
Hico	EQU	21

; Initialise registers................................................

	BANKSEL	ANSEL		; Select Bank 2
	CLRF	ANSEL		; Port C digital I/O
	BSF	ANSEL,0		; except AN0 Analogue input
	CLRF	ANSELH		; Port C digital I/O

	BANKSEL	TRISC		; Select Bank 1
	CLRF	TRISC		; Initialise Port C for output
	MOVLW	B'00010000'	; A/D clock setup code
	MOVWF	ADCON1		; A/D clock = fosc/8

	BANKSEL PORTC		; Select bank 0
	CLRF	PORTC		; Clear display outputs
	MOVLW	B'00000001'	; Analogue input setup code
	MOVWF	ADCON0		; Left justify, Vref=5V, 
				; Select RA0, done, enable A/D 

; Start main loop...............................................
		
	CLRF	PORTC		; LEDs off
	BSF	PORTC,0		; Switch on LED0
loop	RLF	PORTC		; Rotate output LED
	BSF	ADCON0,1	; start ADC..
wait	BTFSC	ADCON0,1	; ..and wait for finish
	GOTO	wait
	MOVF	ADRESH,W	; store result high byte
	MOVWF	Hico
	INCF	Hico		; avoid zero count
	CALL	slow	
	GOTO	loop		; Repeat main loop

; Subroutine....................................................

slow	CLRF	Loco		; delay block
fast	DECFSZ	Loco
	GOTO	fast
	DECFSZ	Hico
	GOTO	slow
	RETURN


	END			; Terminate assembler..........

