;
;       BIN3.ASM		M. Bates                12-10-03      
; ..............................................................
;
;       Slow output binary count is stopped, started
;       and reset with push buttons.
;
;	Processor = 16F84	Clock = CR, 100kHz
;	Inputs: RA0, RA1	Outputs: RB0 - RB7
;
; **************************************************************

; Register Label Equates........................................
        
porta   EQU     05             	; Port A Data Register  
portb   EQU     06             	; Port B Data Register
timer   EQU     0C             	; Spare register for delay

; Input Bit Label Equates ......................................

inres   EQU     0              	; 'Reset' input button = RA0
inrun   EQU     1              	; 'Run' input button = RA1

; **************************************************************

; Initialise Port B (Port A defaults to inputs).................
        
       	MOVLW   00    		; Port B Data Direction Code
    	TRIS    portb          	; Set Port B as outputs
        
; Start main loop ..............................................

reset   CLRF    portb  		; Clear Port B

start   BTFSS  	porta,inres    	; Test RA0 input button
       	GOTO   	reset          	; and reset Port B if pressed
        BTFSC  	porta,inrun    	; Test RA1 input button
        GOTO  	start          	; and run count if pressed

        INCF   	portb          	; Increment count at Port B
  	 
	MOVLW  	0FF            	; Delay count literal
  	MOVWF  	timer          	; Copy W to timer register
down    DECFSZ 	timer          	; Decrement timer register 
        GOTO   	down           	; and repeat until zero

        GOTO   	start          	; Repeat main loop always
        END                   	; Terminate source code


