;***************************
;  BEL1.ASM   MPB 2-12-10
;........................... 
;  Program to output a tone 
;  Sequence (random) of 8 
;  RBO = Output Buzzer 
;  RAO = Input Button 
;  ......................... 
 
	PROCESSOR 16F84

PCL	EQU	02
PortB   EQU    	06
PortA 	EQU    	05
Notnum 	EQU    	0C
Tabnum 	EQU    	0D
Cycnum 	EQU    	0E 
Count  	EQU    	0F
 
;Initialise ...............
          
	MOVLW 	B'11111110'
	TRIS  	PortB 

Wait	BTFSC  	PortA,4 
       	GOTO   	Wait 

; Get note ................

Start	MOVLW   08 
      	MOVWF   Notnum 
Nexnot  MOVF    Notnum,W 
        CALL    Table 
        MOVWF   Tabnum 

; 256 Cycles of note ......

        CLRW 
        MOVWF   Cycnum
Cycle   BSF     PortB,0 
        CALL    Half 
        BCF     PortB,0 
        CALL    Half
        DECFSZ  Cycnum 
        GOTO    Cycle 
 
; Next note of 8 .........
          	
	DECFSZ  Notnum 
        GOTO    Nexnot 
        GOTO    Wait 
 
;Half cycle delay ........
   
Half   	MOVF    Tabnum,W 
        MOVWF   Count 

Down    DECFSZ  Count 
        GOTO    Down 
        RETURN  

;Table of delay values.... 
   
Table  	ADDWF   PCL 
        NOP 
        RETLW   D'124'
        RETLW   D'82' 
        RETLW   D'117'
        RETLW   D'156'
        RETLW   D'77'
        RETLW   D'156'
        RETLW   D'92'
        RETLW   D'104' 

        END	;**********
