;************************************
;  GIT1.ASM   MPB  2-12-10
;  Guitar Tuner 
;  Outputs standard frequencies
;  330,245,196,147,110,82Hz
;  3030,4081,5102,6802,9090,12195us
;  Count = 30,41,51,68,91,122 x50us
;  Measured accurate to about 1%
;  RB0 = buzzer(string tone)
;  RA4 = button(next string)
;
;************************************ 

PortA     EQU       05 
PortB     EQU       06 
String    EQU       0C 
Count1    EQU       0D 
Count2    EQU       0E 
PCL       EQU       02

          PROCESSOR 16F84A

; Initialise ...................

          MOVLW     B'11111110' 
          TRIS      PortB 
	  MOVLW     06 
          MOVWF     String 
          
; Output one cycle .............

Next      BSF       PortB,0 
          CALL      Cycle 
          BCF       PortB,0 
          CALL      Cycle 
          GOTO      Next

; Delay and check inputs ......

Cycle     MOVF      String,W 
          CALL      Table 
	  CALL      Tone
          BTFSS     PortA,4
	  CALL	    Wait1
	  RETURN
          
; Select next tone ...........

Wait1	  BTFSS	    PortA,4
	  GOTO	    Wait1
	  DECFSZ    String
          RETURN
	  MOVLW	    06
	  MOVWF     String
	  RETURN	  


;Table of tone values..........
 
Table     ADDWF     02 
          NOP 
          RETLW     D'122' 
          RETLW     D'91' 
          RETLW     D'68' 
          RETLW     D'51' 
          RETLW     D'41' 
          RETLW     D'30'  

; Subroutine to generate Tone.. 

Tone	  MOVWF     Count1 
Loop1     CALL      Fifty 
          DECFSZ    Count1 
          GOTO      Loop1 
          RETURN   

; Subroutine 50us   delay .....

Fifty     NOP 
	  NOP
          MOVLW     08 
          MOVWF     Count2 
Loop2     NOP 
          NOP
          DECFSZ    Count2 
          GOTO      Loop2
          RETURN
          
	  END	;**************

          
