;*******************************
;	MET1.ASM  MPB  2-12-10
; ..............................
;	Program to output beeps
;	between 0.1-10Hz
;	RB0 = Output Buzzer
;	RA0 = Input Button Up
;	RA1 = Input Button Down
; ..............................
	
	PROCESSOR 16F84A

PortB	EQU	06
PortA	EQU	05
Count1	EQU	0C
Count2	EQU	0D
Count3	EQU	0E
Wait1	EQU	0F
Count0	EQU	10

; Initialise...................

	MOVLW	B'11111110'
	TRIS	PortB
	MOVLW	D'10'
	MOVWF	Wait1

; Main loop...................

start	MOVLW	020     
	MOVWF	Count0
beep	BSF	PortB,0
	CALL	delay1
	BCF	PortB,0
	CALL	delay1
	DECFSZ	Count0
	GOTO	beep

; Read buttons................
               
fup	BTFSS	PortA,0
	DECFSZ	Wait1
	GOTO	fdown
	INCF	Wait1
	
fdown	BTFSS	PortA,1
	INCFSZ	Wait1
	GOTO	Wait
	DECF	Wait1

; Wait 0.1 - 2.5s..........

Wait	MOVF	Wait1,w
	MOVWF	Count3
loop3	CALL	del100
	DECFSZ	Count3
	GOTO	loop3
	GOTO	start

; Wait 100ms...............

del100	MOVLW	D'100'
        MOVWF	Count2
loop2   CALL	delay1
   	DECFSZ	Count2
        GOTO	loop2
        RETURN

; 1ms Delay...............

delay1	MOVLW	D'250'
	MOVWF	Count1
loop1	NOP
	DECFSZ	Count1
	GOTO	loop1
	RETURN      
         
        END	;*********

        
