;******************************
;	REACT1.ASM    	
;	MPB 30-11-10
; 	Reaction time program
;******************************
;	RBO = Buzzer
;       RA4 = Test Input
;       RB1-RR7 = Display
;******************************

	PROCESSOR 16F84A

PortA	EQU	05
PortB	EQU    	06
Random	EQU    	0C
Rtime  	EQU   	0D
Count3 	EQU  	0E
Count2 	EQU  	0F
Count1 	EQU  	10

; Initialise...................

	MOVLW	B'00000000' 
	TRIS	PortB   
	MOVLW	0FF
	MOVWF	PortB

; Generate random count 0-100..

wait   	BTFSC 	PortA,4		
       	GOTO 	wait		
      	CALL 	onehun		
      	CLRW
     	MOVWF	PortB		
reload 	MOVLW 	D'100'		
       	MOVWF  	Random

down  	BTFSC  	PortA,4		
  	GOTO 	randel		
 	DECFSZ 	Random		
	GOTO	down
	GOTO 	reload

; Delay for random time(0-10s)..

randel 	CALL	onehun
	DECFSZ 	Random
	GOTO  	randel

; Beep and start timer(512ms)..

   	CLRF	Rtime
beep 	BSF	PortB,0
    	CALL 	onems
	BCF	PortB,0
	CALL	onems
	BTFSS	PortA,4
	GOTO 	stop
   	INCFSZ	Rtime
	GOTO	beep

; Divide Reaction time by 32..

stop	MOVLW	4
       	MOVWF 	Count3
loop3 	BCF 	3,0
       	RRF  	Rtime
       	DECFSZ 	Count3
       	GOTO  	loop3

; Display reaction time..

	MOVF  	Rtime,W
	CALL 	table
	MOVWF 	PortB
done	CALL 	onehun
	BTFSS	PortA,4
 	GOTO  	done
	GOTO   	wait

;100ms delay............

onehun 	MOVLW	D'100'
	MOVWF	Count2
loop2	CALL	onems
	DECFSZ 	Count2
	GOTO	loop2
	RETURN

; 1ms delay..................

onems 	MOVLW 	D'249'
      	MOVWF 	Count1
loop1 	NOP       
      	DECFSZ	Count1
   	GOTO	loop1
  	RETURN

; Display codes 0-9...........

table 	ADDWF	002
	RETLW 	0EC	; H
	RETLW  	00C	; 1
 	RETLW	0B7	; 2
	RETLW	09E	; 3
	RETLW  	0CC	; 4
	RETLW	0DA	; 5
	RETLW 	0EA	; 6
	RETLW 	00E	; 7
	RETLW  	0FE	; 8
	RETLW	0CE	; 9
	RETLW	0EC	; H
	RETLW 	0EC	; H
	RETLW  	0EC	; H
	RETLW  	0EC	; H
	RETLW 	0EC	; H

       	END

