;*****************************
;  SCALE1.ASM	   
;  MPB	30-11-10
; Outputs a scale of 8 tones
;*****************************

	PROCESSOR 16F84A

; Assign Registers ************

PCL     EQU     02		
PORTA	EQU	05		
PORTB   EQU     06		
HalfT   EQU     0C		
Timer   EQU     0D		
Count   EQU     0E		
TonNum  EQU     0F		

; Initialise Registers .........

       	MOVLW  	B'11111110'	
       	TRIS   	PORTB		
       	GOTO   	wait		

; Tone Period Table (HalfT) ....

getdel 	ADDWF  	PCL		
       	NOP
       	RETLW  	D'156'		
       	RETLW  	D'139'  	
       	RETLW  	D'124'		
       	RETLW  	D'117'		
       	RETLW  	D'104'		
       	RETLW  	D'92'		
       	RETLW 	D'82'		
       	RETLW  	D'77'		

; Delay for half tone cycle .....

delay  	MOVF   	HalfT,W		
       	MOVWF  	Timer
again  	DECFSZ 	Timer
       	GOTO   	again
      	RETURN

; Output 255 cycles of tone .....

note   	MOVLW  	D'255'		
       	MOVWF  	Count

cycle  	BSF	PORTB,0		
       	CALL	delay		
       	NOP			
       	NOP			
       	NOP			
       	BCF	PORTB,0		
       	CALL 	delay
       	DECFSZ	Count		
       	GOTO  	cycle		
       	RETURN			

; Main Loop Outputs 8 Tones ....

wait	BTFSC	PORTA,4		
	GOTO	wait
  	MOVLW  	08		
       	MOVWF  	TonNum		
next	MOVF    TonNum,W	
       	CALL    getdel		
       	MOVWF   HalfT
       	CALL    note		
       	DECFSZ  TonNum		
       	GOTO    next
       	GOTO	wait            
		
	END			
      
		


