; ******************************************************
;   ASD1.ASM            M. Bates   13/11/10	Ver 1.2      
; ******************************************************
;   Assembler directives, a macro and a pseudo-
;   operation are illustrated in this counting 
;   program ...
; ******************************************************

;   Directive sets processor type:
    PROCESSOR 16F84A     

;   Set configuration fuses:
    __CONFIG B'11111111110011'
;   Code protection off, power up timer on, 
;   watchdog timer off, RC clock		

;   SFR equates are inserted from disk file: 
    INCLUDE P16F84A.INC       
                             
;   Constant values can be predefined by directive:
    CONSTANT maxdel=0xFF, dircb=b'00000000'

timer   EQU     0C        ; delay counter register

; Define DELAY macro ***********************************

DELAY   MACRO

        MOVLW   maxdel 	  ; Delay count literal
        MOVWF   timer     ; loaded into spare register

down    DECF    timer     ; Decrement spare register
        BNZ     down      ; Pseudo-Operation:  
                          ; Branch If Not Zero    
        ENDM

;*******************************************************

;       Initialise Port B (Port A defaults to inputs)
        
	BANKSEL	TRISB     ; Select Bank 1
        MOVLW   dircb     ; Port B Data Direction Code
        MOVWF	TRISB     ; Load the DDR code into F86
	BANKSEL	PORTB     ; Reselect Bank 0
        
;       Start main loop ................................

        CLRF    PORTB     ; Clear Port B Data & restart
again   INCF    PORTB     ; Increment count at Port B
        DELAY             ; Insert DELAY macro
        GOTO    again     ; Repeat main loop always

        END               ; Terminate source code
