;	EEP1.ASM	MPB	02-02-11

;	Reads in data at Port A, stores it in EEPROM 
;	and displays it at Port B

	PROCESSOR 16F84A

PCL     EQU     02      ; Program Counter Low
PORTA   EQU     05      ; Port A Data     
PORTB   EQU     06      ; Port B Data
STATUS  EQU     03      ; Flags
EEDATA  EQU     08      ; EEPROM Memory Data
EEADR   EQU     09      ; EEPROM Memory Address
EECON1  EQU     08      ; EEPROM Control Register 1
EECON2  EQU     09      ; EEPROM Control Register 2

RP0     EQU     5       ; STATUS - Register Page Select
RD      EQU     0       ; EECON1 - EEPROM Memory Read Byte Initiate
WR      EQU     1       ; EECON1 - EEPROM Memory Write Byte Initiate
WREN    EQU     2       ; EECON1 - EEPROM Memory Write Enable



Write	MOVF	PORTA,W		; Read in data from port	
	MOVWF   EEDATA          ; Load EEPROM data
	CLRF    EEADR           ; Select first EEPROM location
	BSF     STATUS,RP0      ; Select Register Bank 1
	BSF     EECON1,WREN     ; Enable EEPROM write
	MOVLW   055             ; Write initialisation sequence 
	MOVWF   EECON2          ; 
	MOVLW   0AA             ;
	MOVWF   EECON2          ;
	BSF     EECON1,WR       ; Write data into current address
	BCF     EECON1,WR       ; 	
	BCF     EECON1,WREN     ; Disable EEPROM write	
	BCF     STATUS,RP0      ; Re-select Register Bank 0 
		

Read	BSF     STATUS,RP0      ; Select Register Bank 1
	BSF     EECON1,RD       ; Enable EEPROM read
	BCF     STATUS,RP0      ; Re-select Register Bank 0
	MOVF    EEDATA,W        ; Copy EEPROM data to W
	BSF     STATUS,RP0      ; Select Register Bank 1
	BCF     EECON1,RD       ; Disable EEPROM read
	CLRF	PORTB		; Set PortB as outputs
	BCF     STATUS,RP0      ; Re-select Register Bank 0
	MOVWF	PORTB		; Display data
	
	SLEEP

	END
		