;********************************************************
;       TAB1.ASM       	MPB  4-2-11
;********************************************************
;
;   Output binary sequence gives a demonstration of a 
;   bar graph display, using a program data table..
;
; *******************************************************

	PROCESSOR 16F84A

; Register Label Equates...............................
        
PCL     EQU     02         ; Program Counter Low
PORTB   EQU     06         ; Port B Data Register
timer   EQU     0C         ; GPR1 used as delay counter
point   EQU     0D         ; GPR2 used as table pointer

; *******************************************************
        
        ORG     000
        GOTO    start      ; Jump to start of main prog

; Define DELAY subroutine.............................

delay   MOVLW   0xFF       ; Delay count literal
        MOVWF   timer      ; loaded into spare register
down    DECFSZ  timer      ; Decrement timer register 
        GOTO    down       ; and repeat until zero 
        RETURN             ; then return to main program 

; Define Table of Output Codes .......................

table   ADDWF   PCL        ; Add pointer to PCL
        RETLW   000        ; 0 LEDS on          
        RETLW   001        ; 1 LEDS on
        RETLW   003        ; 2 LEDS on
        RETLW   007        ; 3 LEDS on
        RETLW   00F        ; 4 LEDS on
        RETLW   01F        ; 5 LEDS on
        RETLW   03F        ; 6 LEDS on
        RETLW   07F        ; 7 LEDS on
        RETLW   0FF        ; 8 LEDS on

; Initialise Port B (Port A defaults to inputs)........

start   MOVLW   b'00000000' ; Port B Data Direction
        TRIS    PORTB       ; and load into TRISB

; Main loop ...........................................

newbar  CLRF    point       ; Reset pointer   
nexton  MOVLW   009         ; Check if all done yet 
        SUBWF   point,W     ; (note: destination W)
        BTFSC   3,2         ; and start a new bar
        GOTO    newbar      ; if true...
        MOVF    point,W     ; Set pointer to
        CALL    table       ; access table...
        MOVWF   PORTB       ; and output to LEDs
        CALL    delay       ; wait a while...
        INCF    point       ; Point to next value
        GOTO    nexton      ; and repeat...

        END                 ; Terminate source code


