;************************************************************
;	DCM1.ASM	MPB  Ver 1.0
;	Test program for DC motor demo board MOT2
; 	S1 = Forward, S2 = Reverse
;
;************************************************************

	PROCESSOR 16F690	; Specify MCU for assembler
				; MCU configuration bits
	__CONFIG 00E4		; PWRT on, MCLR enabled 
				; Internal Clock 
				; Default = 4MHz
	INCLUDE "P16F690.INC"	; Standard register labels

; Initialise registers.......................................

	BANKSEL	ANSEL		; Select Bank 2
	CLRF	ANSEL		; Port A digital I/O
	MOVLW	B'00001100'	; Input setup code
	MOVWF	ANSELH		; RB6, RB7 digital input

	BANKSEL	TRISA		; Select Bank 1
	MOVLW	B'11001111'	; PortA setup code
	MOVWF	TRISA		; RA4, RA5 output
	BANKSEL	PORTA		; Reselect Bank 0

; Start main loop..........................................
		
	CLRF	PORTA		; Both FETs off
S1	BTFSS	PORTB,6		; Test S1
	GOTO	For
	BCF	PORTA,4		; If not,off
	GOTO	S2
For	BSF	PORTA,4		; If on, forward

S2	BTFSS	PORTB,7		; Test S2
	GOTO	Rev
	BCF	PORTA,5		; If not,off
	GOTO	S1
Rev	BSF	PORTA,5		; If on, reverse
	GOTO	S1		; repeat always

	END	; Terminate assembler......................

